//----------------------------------------------------------------------
// Joining2.java
// Author: Bob Dondero
//----------------------------------------------------------------------

class PrinterRunnable implements Runnable
{
   private String color;

   public PrinterRunnable(String color) { this.color = color; }

   public void run()
   {
      for (int i = 0; i < 10; i++)
         System.out.println(color);
      System.out.println(color + " thread terminated");
   }
}

//----------------------------------------------------------------------

public class Joining2
{
   public static void main(String[] args)
   {
      Runnable bluePrinterRunnable = new PrinterRunnable("blue");
      Runnable redPrinterRunnable = new PrinterRunnable("red");

      Thread blueThread = new Thread(bluePrinterRunnable);
      Thread redThread = new Thread(redPrinterRunnable);

      blueThread.start();
      redThread.start();

      try
      {
         blueThread.join();
         redThread.join();
      }
      catch (InterruptedException e)
      {
         Thread.currentThread().interrupt();
      }

      System.out.println("main thread terminated");
   }
}

