#!/usr/bin/env python

#-----------------------------------------------------------------------
# joining.py
# Author: Bob Dondero
#-----------------------------------------------------------------------

import threading

#-----------------------------------------------------------------------

class PrinterThread (threading.Thread):

    def __init__(self, color):
        threading.Thread.__init__(self)
        self._color = color

    def run(self):
        for i in range(10):
            print(self._color)
        print(self._color + ' thread terminated')

#-----------------------------------------------------------------------

def main():

    blueThread = PrinterThread('blue')
    redThread = PrinterThread('red')

    blueThread.start()
    redThread.start()

    blueThread.join()
    redThread.join()

    print('main thread terminated')

#-----------------------------------------------------------------------

if __name__ == '__main__':
    main()
